﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Evil : Token {

    public Token targetPlayer;
    public Heart[] hearts;

    protected override void OnTriggerStay2D(Collider2D collision) {
        base.OnTriggerStay2D(collision);
    }
    
    protected override void OnTriggerEnter2D(Collider2D collision) {
        base.OnTriggerEnter2D(collision);

        if (collision.gameObject.tag == "Heart") {
            collision.gameObject.GetComponent<Heart>().OnCollected();
            GetComponent<AudioControl>().PlayClip(0);
        }

        if (stayPlace == targetPlayer.stayPlace || collision.gameObject.name == "Rocket") {
            OnCrashPlayer();
        }
        /*
        foreach (Heart heart in hearts) {
            if (stayPlace == heart.place) {
                OnCrashHeart();
            }
        }
        */
    }

    public void DisableRoutes() {
        redLines[0].SetActive(true);
    }

    public void OnCrashPlayer() {
        GameManager.Instance.PlayerDie();
        GetComponent<AudioControl>().PlayClip(2);
        //SetState(-3);
    }

    public void OnCrashHeart() {
        GameManager.Instance.HeartDie();
    }

    public override void OnLost() {
        base.OnLost();
        SetState(-1);
        GetComponent<AudioControl>().PlayClip(1);
        GameManager.Instance.EvilLost();
        Debug.Log("Evil Lost");

        DisableRoutes();
    }

    public void OnSuccess() {
        GameManager.Instance.EvilWin();
    }

    public override void ReachEnd() {
        base.ReachEnd();

        if (stayPlace.x == 1) {
            
            greenLines[0].SetActive(true);
            OnSuccess();

        } else {
            redLines[0].SetActive(true);
            OnLost();
        }
    }

}
