﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameManager : Singleton<GameManager> {

    public Rocket rocket;
    public Evil evil;

    public bool rocketWin;
    public bool evilWin;

    public GameObject winMenu;
    public AudioSource winSound;

    private void Awake() {
        winMenu.SetActive(false);
    }

    public void HeartRemain() {
        Debug.Log("Heart Remain");
    }

    public void HeartDie() {
        Debug.Log("Heart Die");
    }

    public void PlayerDie() {
        Debug.Log("Player Die");
        rocket.StopAllCoroutines();
        evil.StopAllCoroutines();
        rocket.SetState(-3);
        evil.SetState(-3);
        rocket.DisableRoutes();
        evil.DisableRoutes();
    }

    public void PlayerLost() {
        Debug.Log("Player Lost");
        rocket.StopAllCoroutines();
        evil.StopAllCoroutines();
    }

    public void EvilLost() {
        Debug.Log("Evil Lost");
        rocket.StopAllCoroutines();
        evil.StopAllCoroutines();
    }

    public void RocketWin() {
        rocketWin = true;
        if (evilWin) {
            Win();
        }
    }

    public void EvilWin() {
        evilWin = true;
        if (rocketWin) {
            Win();
        }
    }

    public void Win() {
        Debug.Log("Win!!!");
        winMenu.SetActive(true);
        winSound.Play();
    }

    public void Reset() {
        rocketWin = false;
        evilWin = false;
        winMenu.SetActive(false);
    }

}
