﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Rocket : Token {

    public bool isFull = false;
    public int heartAmount = 0;

    public int step = 0;

    private void Update() {
        if (stayPlace.y == 3 && heartAmount == 0) {
            redLines[0].SetActive(true);
            step++;
        }

        if (stayPlace.y == 1 && ((redLines[0].activeSelf && heartAmount == 0) || (!redLines[0].activeSelf && heartAmount == 1))) {
            redLines[1].SetActive(true);
            step++;
        }
    }

    protected override void OnTriggerStay2D(Collider2D collision) {
        base.OnTriggerStay2D(collision);
    }

    protected override void OnTriggerEnter2D(Collider2D collision) {
        base.OnTriggerEnter2D(collision);

        if (collision.gameObject.tag == "Heart") {
            OnCollect();
            collision.gameObject.GetComponent<Heart>().OnCollected();

            if (stayPlace.y == 4) {
                greenLines[0].SetActive(true);
                step++;
            }
            if (stayPlace.y == 2) {
                greenLines[1].SetActive(true);
                step++;
            }
        }
        /*
        if (collision.gameObject.tag == "Target" && collision.gameObject.name == "Planet") {
            greenLines[2].SetActive(true);
            if (isFull) {
                OnSuccess();
            } else {
                OnFail();
            }
        }
        */
    }

    public void OnCollect() {
        GetComponent<AudioControl>().PlayClip(0);

        if (stayPlace.y == 4) {
            greenLines[0].SetActive(true);
            step++;
        }
        if (stayPlace.y == 2) {
            greenLines[1].SetActive(true);
            step++;
        }
        
        heartAmount++;
        if (heartAmount >= 2) {
            isFull = true;
        }
    }

    public void OnSuccess() {
        //SetState(1);
        GameManager.Instance.RocketWin();
    }

    public void OnHungry() {
        GameManager.Instance.HeartRemain();
    }

    public override void OnLost() {
        base.OnLost();
        SetState(-1);
        GameManager.Instance.PlayerLost();
        DisableRoutes();
    }

    public void DisableRoutes() {
        for (int i = step; i < redLines.Length; i++) {
            redLines[i].SetActive(true);
        }
    }

    public override void ReachEnd() {
        base.ReachEnd();

        if (stayPlace.x == 2) {

            greenLines[2].SetActive(true);
            if (isFull) {
                OnSuccess();
            } else {
                OnHungry();
            }

        } else {
            redLines[2].SetActive(true);
            OnLost();
        }
    }

    public override void Reset() {
        base.Reset();
        heartAmount = 0;
        isFull = false;
        step = 0;
    }

}
