﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Switch : MonoBehaviour {

    public GameObject[] tiles;
    public Vector2[] places = new Vector2[3];
    public Vector3[] positions = new Vector3[3];

    private void Awake() {
        
    }

    // Use this for initialization
    void Start () {
        SavePositions();
        SavePlace();
    }
	
	// Update is called once per frame
	void Update () {
		
	}

    public void SwitchTiles(string direction) {
        
        switch (direction) {
            case "Left":
                tiles[0].GetComponent<Tile>().place = places[2];
                tiles[1].GetComponent<Tile>().place = places[0];
                tiles[2].GetComponent<Tile>().place = places[1];

                tiles[0].transform.position = positions[2];
                tiles[1].transform.position = positions[0];
                tiles[2].transform.position = positions[1];

                SavePositions();
                SavePlace();
                break;

            case "Right":
                tiles[0].GetComponent<Tile>().place = places[1];
                tiles[1].GetComponent<Tile>().place = places[2];
                tiles[2].GetComponent<Tile>().place = places[0];

                tiles[0].transform.position = positions[1];
                tiles[1].transform.position = positions[2];
                tiles[2].transform.position = positions[0];

                SavePositions();
                SavePlace();
                break;
        }
        
        foreach (GameObject tile in tiles) {
            TileManager.Instance.SetTileAt(tile.GetComponent<Tile>().place, tile.GetComponent<Tile>());
        }

        foreach (GameObject tile in tiles) {
            tile.GetComponent<Tile>().FindAdjacent();
        }
    }

    private void SavePositions() {
        for (int i = 0; i < tiles.Length; i++) {
            positions[i] = tiles[i].transform.position;
        }
    }

    private void SavePlace() {
        for (int i = 0; i < tiles.Length; i++) {
            places[i] = tiles[i].GetComponent<Tile>().place;
        }
    }


}
