﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TileManager : Singleton<TileManager> {

    public List<Tile> tileObjects = new List<Tile>();
    public Dictionary<Vector2, Tile> tiles = new Dictionary<Vector2, Tile>();

    public Tile rocketGoal;
    public Tile evilGoal;

    private void Awake() {
        /*
        foreach (GameObject tileObject in GameObject.FindGameObjectsWithTag("Tile")) {
            tileObjects.Add(tileObject.GetComponent<Tile>());
        }
        

        int i = 0;
        for (int x = 1; x <= 3; x++) {
            for (int y = 1; y <= 6; y++) {
                tiles.Add(new Vector2(x, y), tileObjects[i]);
                tileObjects[i].place = new Vector2(x, y);
                i++;
            }
        }
        */

        int i = 0;
        for (int y = 1; y <= 6; y++)
        {
            for (int x = 1; x <= 3; x++)
            {
                tiles.Add(new Vector2(x, y), tileObjects[i]);
                tileObjects[i].place = new Vector2(x, y);
                i++;
            }
        }
    }

    private void Start() {
        //Debug.Log(tiles.Keys);
        //Debug.Log(tiles.Values);
    }

    public Tile GetTileAt(Vector2 place) {
        if (tiles.ContainsKey(place)) {
            return tiles[place];
        } else {
            return null;
        }
    }

    public void SetTileAt(Vector2 place, Tile tile) {
        tiles[place] = tile;
    }

    public float GetBorderX() {
        return 6.4f;
    }

    public float GetBorderY() {
        return 4.5f;
    }

}
